#pragma once

#include "../State/IState.h"
#include "../State/SelectState.h"

#include <iostream>
#include <memory>

class Application : public IStateManager {
public:
    Application();
    int run();
    ~Application() override = default;

private:
    void set_next_state(std::unique_ptr<IState>&& ptr_state) override;
    void apply_deffer_state_change() noexcept;

private:
    std::unique_ptr<IState>  m_ptr_state_next;
    std::unique_ptr<IState> m_ptr_state_current;
};

