#include "Texture_Sound.h"
#include "../../../config.h"

sf::Font& MyAssets_one::GetFont() {
    static sf::Font font;
    if (!font.getInfo().family.empty()) return font;
    if (!font.loadFromFile(std::string(ASSETS_PATH) +std::string(config::FONT_FILE)))
        throw std::runtime_error("Failed to load font");
    return font;
}

sf::SoundBuffer &MyAssets_one::GetSound() {
    static sf::SoundBuffer buffer;
    if (buffer.getSampleCount() == 0) {
        if (!buffer.loadFromFile(ASSETS_PATH "eat_food.mp3"))
            throw std::runtime_error("Failed to load sound");
    }
    return buffer;
}

sf::SoundBuffer &MyAssets_one::GetSoundWin() {
    static sf::SoundBuffer buffer;
    if (buffer.getSampleCount() == 0) {
        if (!buffer.loadFromFile(ASSETS_PATH "win_game.mp3"))
            throw std::runtime_error("Failed to load sound win");
    }
    return buffer;
}

sf::SoundBuffer &MyAssets_one::GetSoundLost() {
    static sf::SoundBuffer buffer;
    if (buffer.getSampleCount() == 0) {
        if (!buffer.loadFromFile(ASSETS_PATH "lost_game.mp3"))
            throw std::runtime_error("Failed to load sound lost");
    }
    return buffer;
}

sf::SoundBuffer &MyAssets_one::GetSoundInGame() {
    static sf::SoundBuffer buffer;
    if (buffer.getSampleCount() == 0) {
        if (!buffer.loadFromFile(ASSETS_PATH "ingame.mp3"))
            throw std::runtime_error("Failed to load sound ingame");
    }
    return buffer;
}

sf::SoundBuffer &MyAssets_one::GetSceamer() {
    static sf::SoundBuffer buffer;
    if (buffer.getSampleCount() == 0) {
        if (!buffer.loadFromFile(ASSETS_PATH "ingame.mp3"))
            throw std::runtime_error("Failed to load sound ingame");
    }
    return buffer;
}

sf::Texture &MyAssets_one::GetScreamerTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0}) return texture;
    if (!texture.loadFromFile(ASSETS_PATH "screamer.png"))
        throw std::runtime_error("Failed to load Screamer Texture");
    return texture;
}


//@todo
//sf::Texture& MyAssets_one::GetFood() {
//    static sf::Texture food;
//    if (food.getSize() != sf::Vector2u{0, 0}) return food;
//    if (!food.loadFromFile(std::string(ASSETS_PATH) + "grusha.png"))
//        throw std::runtime_error("Failed to load texture for food");
//    return food;
//}
//
//sf::Texture& MyAssets_one::GetEnemy() {
//    static sf::Texture food;
//    if (food.getSize() != sf::Vector2u{0, 0}) return food;
//    if (!food.loadFromFile(std::string(ASSETS_PATH) + "enemy.png"))
//        throw std::runtime_error("Failed to load texture for Enemy");
//    return food;
//}
//
//sf::Texture& MyAssets_one::GetBackground() {
//    static sf::Texture food;
//    if (food.getSize() != sf::Vector2u{0, 0}) return food;
//    if (!food.loadFromFile(std::string(ASSETS_PATH) + "background.png"))
//        throw std::runtime_error("Failed to load texture for Enemy");
//    return food;
//}
