#pragma once
#include "IGameBuilder.h"

class GameBuilderDirector {
public:
    GameBuilderDirector(std::unique_ptr<IGameBuilder>&& ptr_builder, sf::VideoMode mode, std::string  window_title, float dynamic_objects_ratio);
    std::unique_ptr<GameState> build(IStateManager& state_manager, int players);

private:
    std::string m_window_title;
    sf::VideoMode m_mode;
    float m_dynamic_object_ratio;
    std::unique_ptr<IGameBuilder> m_ptr_builder;
};