#pragma once
#include "IGameBuilder.h"
#include "../Context/Context.h"
#include "../../../config.h"

class CommonBuilder : public IGameBuilder {
public:
    CommonBuilder(float width, float height, float room_size);
    void create_context(float dynamic_objects_ratio, int players) override;
    void create_state(IStateManager& state_manager, const sf::VideoMode& mode, const std::string& window_title) override;
    void set_all_to_state() override;
    std::unique_ptr<GameState> get_game() override;

protected:
    float m_width;
    float m_height;
    float m_room_size;
    std::vector<std::vector<Room*>> m_rooms;
    GameContext m_context;
    std::unique_ptr<GameState> m_game_state;
};

class SimpleBuilder : public CommonBuilder {
public:
    using CommonBuilder::CommonBuilder;
    void create_rooms() override;
    void set_rooms_sides() override;
};

class ComplexBuilder : public CommonBuilder {
public:
    using CommonBuilder::CommonBuilder;
    void create_rooms() override;
    void set_rooms_sides() override;
};