#pragma once
#include "../../IDrawable.h"
#include "../../../State/IState.h"
#include "../../../SelectCommand/ISelectCommand.h"

#include <memory>

class Button : public IDrawable {
public:
    //@todo add Button()
    Button(sf::Vector2f pos, sf::Vector2f button_size,
             const std::string& text, size_t font_size,
             std::unique_ptr<ISelectCommand> ptr_command); //@todo change to set
    void select();
    void unselect();
    bool is_selected() const noexcept;
    bool is_position_in(sf::Vector2f pos) const noexcept;
    void push();
    void draw_into(sf::RenderWindow& window) override;

private:
    sf::Text m_text;
    bool m_is_selected = false;
    sf::RectangleShape m_rectangle;
    std::unique_ptr<ISelectCommand> m_ptr_command;
};

class ChooseButton : public IDrawable {
public:
    ChooseButton(sf::Vector2f pos, const std::string& text, size_t font_size);
    void select() { m_is_selected = true; }
    void unselect() { m_is_selected = false; }
    bool is_selected() const noexcept { return m_is_selected; }
    bool contains(sf::Vector2f point) const;
    void draw_into(sf::RenderWindow& window) override;
private:
    sf::Text m_text;
    bool m_is_selected = false;
    sf::CircleShape m_out_circle;
    sf::CircleShape m_in_circle;
};