#pragma once

#include "IEntity.h"
#include "../Maze/Maze.h"
#include "MyTexture.h"
#include "SFML/Audio/Sound.hpp"

class Pacman : public IEntity, public IVisitor {
public:
    Pacman(MyTexture* texture);
    void move(Room::Direction direction);
    void prepare_for_drawing() override;
    void set_texture(MyTexture* ptr_texture) { m_ptr_texture = ptr_texture; }
    void draw_into(sf::RenderWindow& window) override;
    std::unique_ptr<IGameEvent> visit(Food* ptr_entity) override;
    std::unique_ptr<IGameEvent> visit(Enemy* ptr_entity) override;
    ~Pacman() override {};
private:
    sf::Sprite m_sprite;
    sf::Sound m_sound;
    MyTexture* m_ptr_texture;
};
