#include "IGameEvent.h"
#include "../Context/Context.h"
#include "../Assets/Texture_Sound.h"

void LostGame::handle(GameContext* context) {
    context->state = GameContext::LOST;
}

void DeleteStaticEntity::handle(GameContext* context) {
    auto it = std::find_if(context->static_objects.begin(), context->static_objects.end(),
                           [this](const std::unique_ptr<IStaticEntity>& ptr) { return ptr.get() == m_ptr_entity; });
    context->static_objects.erase(it);
}

DeleteStaticEntity::DeleteStaticEntity(IStaticEntity* ptr_entity) :
        m_ptr_entity(ptr_entity) {
}

void WinGame::handle(GameContext* context) {
    context->state = GameContext::WIN;
}

void ScreamerEvent::handle(GameContext *context) {
    if (!context->screamer_active) {
        context->screamer_active = true;
        context->screamer_timer = 1.0f;
        m_sound.setBuffer(MyAssets_one::GetSceamer());
        m_sound.play();
    }
}
