#pragma once

#include <iostream>
#include <list>
#include "SFML/Audio/Sound.hpp"

class GameContext;
class IStaticEntity;

class IGameEvent {
public:
    virtual void handle(GameContext* context) = 0;
    virtual ~IGameEvent() = default;
};

class WinGame : public IGameEvent {
public:
    void handle(GameContext* context) override;
};

class LostGame : public IGameEvent {
public:
    void handle(GameContext* context) override;
};

class DeleteStaticEntity : public IGameEvent {
public:
    DeleteStaticEntity(IStaticEntity* ptr_entity);
    void handle(GameContext* context) override;
private:
    IStaticEntity* m_ptr_entity;
};

struct ScreamerEvent : public IGameEvent {
    void handle(GameContext* context) override;
    sf::Sound m_sound;
};

class ScreamerCompositeEvent : public IGameEvent {
public:
    ScreamerCompositeEvent(IStaticEntity* food) : m_food(food) {}
    void handle(GameContext* context) override {
        DeleteStaticEntity(m_food).handle(context);
        ScreamerEvent().handle(context);
    }
private:
    IStaticEntity* m_food;
};