#pragma once
#include "IState.h"
#include "../Drawable/DrawMenu/Menu/Menu.h"
#include "ThemeManager.h"

struct SelectState: public IState, public IWindowKeeper {
    SelectState(IStateManager& state_manager, const sf::VideoMode& video_mode, const std::string& window_title);
    void event_handling() override;
    void set_texture(MyTexture* ptr_texture) { m_background = ptr_texture; }
    void update() override;
    void render() override;
    bool do_step() override;
private:
    void update_theme() { ThemeManager::Instance().applyTheme(); }
    MyTexture* m_background;
    sf::Sprite m_backgorund_sprite;
    Menu m_menu;
};